﻿window.addEventListener("DOMContentLoaded", init);

var TMan = new N6LTimerMan();  //タイマーマネージャー
var dt = Math.floor(1000 / 20); //20FPS
var bt = 0;
var dt2 = Math.floor(1250 / 25); //bat
var cvpoints;
var q0;
var q1;
var q2;
var q01;
var bl = -25;
var ball;
var grv = -0.0015;
var ine = -0.0005;
var dt3 = Math.floor(2500 / 50); //ball
var frmpermsec = 500 * dt3 / 2500;
var pt = [['fastball', 120, 160, 12, -50, 50, 12, -5, 5, 12, -10, 10],
          ['curveball', 90, 135, 10, -180, -120, 12, -8, -4, 100, 0, 0],
          ['slider', 90, 135, 10, -180, -150, 12, -12, -10, 100, 0, 0],
          ['hardsinker', 120, 145, 14, 120, 200, 13, -10, -8, 100, 0, 0],
          ['sinkingfastball', 110, 135, 12, -160, -90, 12, -15, -10, 12, -10, -5],
          ['cutter', 110, 140, 10, -110, -60, 12, -8, -4, 12, -5, 0],
          ['screwball', 80, 120, 8, -200, -120, 10, -12, -8, 12, -8, -4],
          ['splitter', 115, 140, 14, -180, -100, 12, -12, -8, 13, -8, -4],
          ['forkball', 80, 120, 12, -110, -60, 10, -15, -12, 12, -15, -5],
          ['sinker', 100, 120, 12, 90, 160, 12, -14, -10, 12, -10, -5],
          ['changeup', 60, 80, 12, -80, 80, -100, 50, 80, 12, -10, -5]];
var fp = 100000;
var bound = 0;
var faul = 1.2;
var easy = 2;
var easy0base = 0.25;
var easy0rate = 0.15;
var easy1base = 0.15;
var easy1rate = 0.1;
var easy2base = 0.4;
var easy2rate = 0.05;
var easy0 = easy * easy0rate + easy0base;
var easy1 = easy * easy1rate + easy1base;
var easy2 = easy * easy2rate + easy2base;


function init() {
  const width = 500;
  const height = 250;

  const renderer = new THREE.WebGLRenderer({
    canvas: document.querySelector("#cnv0")
  });
  renderer.setPixelRatio(window.devicePixelRatio);
  renderer.setSize(width, height);
  const scene = new THREE.Scene();
  const camera = new THREE.PerspectiveCamera(
    45,
    width / height,
    1,
    1000
  );
  camera.position.set(0, 0.7, -1.5);
  camera.lookAt( 0, 0.7, 0 );
  scene.background = new THREE.Color( '#205030' );

  // 箱を作成
  const boxgeometry = new THREE.BoxGeometry(0.25, 0.9, 0.25);
  // マテリアルに色を設定
  const boxmaterial = new THREE.MeshBasicMaterial( { color: '#40a0a0' } );
  // メッシュを作成
  const box = new THREE.Mesh(boxgeometry, boxmaterial);
  box.position.set(0, 0.9, 18);
  // 箱を作成
  const batgeometry = new THREE.BoxGeometry(0.05, 0.175, 0.05);
  // マテリアルに色を設定
  const batmaterial = new THREE.MeshBasicMaterial( { color: '#808080' } );
  // メッシュを作成
  const bat = new THREE.Mesh(batgeometry, batmaterial);
  bat.position.set(0.3, 1.0, -0.3);
  // 球を作成
  const sphgeometry = new THREE.SphereGeometry(0.05,32,32);
  // マテリアルに色を設定
  const sphmaterial = new THREE.MeshBasicMaterial({ color: '#ffffff'});
  // メッシュを作成
  const sph = new THREE.Mesh(sphgeometry, sphmaterial);
  sph.position.set(0, 2, 18);
  // 影を作成
  const sdwgeometry = new THREE.SphereGeometry(0.05,32,32);
  // マテリアルに色を設定
  const sdwmaterial = new THREE.MeshBasicMaterial({ color: '#000000'});
  // メッシュを作成
  const sdw = new THREE.Mesh(sdwgeometry, sdwmaterial);
  sdw.position.set(0, 0, 18);
  // ストライクゾーンを作成
  const strpoints = [];
  strpoints.push( new THREE.Vector3( -0.21, 1.05, 0 ) );
  strpoints.push( new THREE.Vector3( -0.21, 0.4, 0 ) );
  strpoints.push( new THREE.Vector3( 0.21, 0.4, 0 ) );
  strpoints.push( new THREE.Vector3( 0.21, 1.05, 0 ) );
  strpoints.push( new THREE.Vector3( -0.21, 1.05, 0 ) );
  const strgeometry = new THREE.BufferGeometry().setFromPoints( strpoints );
  // メッシュを作成
  var str = new THREE.Line( strgeometry, new THREE.LineBasicMaterial( { color: '#008080' } ) );
  // ファウルを作成
  const flpoints = [];
  flpoints.push( new THREE.Vector3( 0, 0, 0 ) );
  flpoints.push( new THREE.Vector3( 60, 0, 60 ) );
  flpoints.push( new THREE.Vector3( 35, 0, 80 ) );
  flpoints.push( new THREE.Vector3( 0, 0, 100 ) );
  flpoints.push( new THREE.Vector3( -35, 0, 80 ) );
  flpoints.push( new THREE.Vector3( -60, 0, 60 ) );
  flpoints.push( new THREE.Vector3( 0, 0, 0 ) );
  const flgeometry = new THREE.BufferGeometry().setFromPoints( flpoints );
  // メッシュを作成
  var fl = new THREE.Line( flgeometry, new THREE.LineBasicMaterial( { color: '#808080' } ) );
  // シーンに追加
  scene.add(box);
  scene.add(bat);
  scene.add(sph);
  scene.add(sdw);
  scene.add(str);
  scene.add(fl);

  // 平行光源
  const light = new THREE.DirectionalLight(0xffffff);
  light.position.set(0, 1, 0);
  // シーンに追加
  scene.add(light);

  TMan.add();
  TMan.timer[0].setalerm(function() { Loop(0); }, dt);  //メインループセット
  TMan.add();
  TMan.add();

  function hit(vec, pow) {
    var vxz0 = new N6LVector([0.2, 0]);
    var vxz1 = new N6LVector([vec.x[1], vec.x[3]]);
    var thxz= vxz1.Theta(vxz0);
    thxz = thxz + (Rand(0, 200) - 100.0) / 100.0 * 30.0 * Math.PI / 180.0;
    var vyz0 = new N6LVector([0.7, 0]);
    var vyz1 = new N6LVector([vec.x[2], vec.x[3]]);
    var thyz= vyz1.Theta(vyz0);
    thyz =  thyz + (Rand(0, 200) - 100.0) / 100.0 * 30.0 * Math.PI / 180.0 + Math.PI;
    var ax = new N6LVector(4, true).UnitVec(1);
    var ay = new N6LVector(4, true).UnitVec(2);
    var mat = new N6LMatrix(4).UnitMat().RotAxis(ay, thxz).RotAxis(ax, thyz);
    var vec = new N6LVector([1, 0, 0, Rand(50, 100) / 100.0 * pow * pow / 100.0 *  ball[5] * 1000 / 60 / 60 / 1000 * frmpermsec * 100], true);
    vec = mat.Mul(vec);
    ball[1][0] = vec.x[1];
    ball[1][1] = vec.x[2];
    ball[1][2] = vec.x[3];
    var txt = document.querySelector("#dbg");
    txt.value = "Hit!!";
  }

  function ontube(p0, q0, w0, d0, p1, q1, w1, d1, pow) {
  
    var reta = [];
    var retb = [];
    var wk = new N6LVector(4, true);
    var d = wk.DistancePointLineLine(reta, retb, p0, p1, q0, q1);

    var abs0 = q0.Sub(p0).Abs();
    var dd0 = reta[0].Sub(p0).Abs();
    var abs1 = q1.Sub(p1).Abs();
    var dd1 = retb[0].Sub(p1).Abs();


    if(d < w0 + w1){
      if((dd0 <= abs0) && (dd1 <= abs1)){
        if((d != 0.0) && (dd0 != 0.0) && (dd1 != 0.0)){
          pow[0] =(((w0 + w1) / d) + (abs0 / dd0) + (abs1 / dd1)) / 3;
          if(100.0 < pow[0]) pow[0] = 100.0;
        }
        else pow[0] = 100.0;
        return true;
      }
    }
    pow[0] = 0.0;
    return false;
  }

  function ishit(vec, el, pow) {
    if(0 <= bl){

      var ax = new N6LVector(4, true).UnitVec(1);
      var ay = new N6LVector(4, true).UnitVec(2);
      var az = new N6LVector(4, true).UnitVec(3);
      var mat = new N6LMatrix(4).UnitMat();
      mat = mat.RotAxis(az, el.x[3]).RotAxis(ay, el.x[2]).RotAxis(ax, el.x[1]).NormalMat();
      var as0 = mat.GetRow(2).NormalVec();
      var as1 = new N6LVector([1, ball[1][0], ball[1][1], ball[1][2]], true).NormalVec();
      var p0 = new N6LVector(vec);
      var p1 = new N6LVector([1, ball[0][0] + ball[1][0] / 2, ball[0][1] + ball[1][1] / 2, ball[0][2] + ball[1][2] / 2], true).NormalVec();
//      var w0 = 0.075;
//      var w1 = 0.05;
//      var d0 = 0.35;
      var w0 = easy0;
      var w1 = easy1;
      var d0 = easy2;
      var d1 = Math.sqrt(ball[1][0] * ball[1][0] + ball[1][1] * ball[1][1] + ball[1][2] * ball[1][2]);
      var q0 = as0.Mul(d0);
      var q1 = as1.Mul(d1);

      if((ontube(p0, q0, w0, d0, p1, q1, w1, d1, pow)) && (-0.5 < ball[0][2]) && (ball[0][2] < 1.5) && (bound == 0) && (0.35 <= ball[0][1]) && (ball[0][1] <= 1.1) &&
         (-0.3 < ball[0][0]) && (ball[0][0] < 0.3) )
        return true;

    }
    return false;
  }

  function ishomerun(){
    var vec = new N6LVector([1, ball[0][0], ball[0][1], ball[0][2]]);
    var r = vec.Abs();
    if((80 <= r) && (bound < 3)){
      if(((0 <= vec.x[1]) && (vec.x[1] <= vec.x[3])) || ((vec.x[1] <= 0) && (vec.x[3] <= vec.x[1])))
        return true;
    }
    return false;
  }
  function ballout(pos) {
    if(pos.x[3] < -2)
      return true;
    var r = pos.Abs();
    if(140 < r) {
        if(ishomerun()){
          var txt = document.querySelector("#hr");
          txt.value = parseInt(txt.value) + 1; 
          var txt = document.querySelector("#dbg");
          txt.value = "HomeRun!!!!!!"; 
        }

      return true;
   }
   if(((0 <= pos.x[1]) && (pos.x[3] * faul <= pos.x[1])) || ((pos.x[1] <= 0) && (pos.x[1] <= pos.x[3] * faul)))
      if((0 < bound) && (15 < r))
      return true;
    return false;
  }

  function rdochg(){
    var radioList = document.getElementsByName("EASY");
    var i;
    for(i = 0; i < radioList.length; i++){
      if(radioList.checked) break;
    }
    easy = i;
    easy0 = easy * easy0rate + easy0base;
    easy1 = easy * easy1rate + easy1base;
    easy2 = easy * easy2rate + easy2base;
  }

  function Loop(id) {
  
    // レンダリング
    renderer.render(scene, camera);

    TMan.timer[id].setalerm(function() { Loop(id); }, dt);  //メインループセット

    if(bl < 0) bl++;
    else if(bl == 0)  BallLoop(2);

  }

  function BallLoop(id) {
    if(bl == 0) { // throw
      var txt = document.querySelector("#pt");
      txt.value = parseInt(txt.value) + 1; 


      ball = [];
      ball[0] = [0, 2, 18];//pos
      ball[1] = [0, 0, 0];//vel
      ball[2] = [0, 0, 0];//acc
      var rx = Math.round((Rand(0,300) -150.0) / 100.0);
      var ry = Math.round((Rand(0,300) -150.0) / 100.0);
      ball[3] = [(2.0 * (Rand(0, 200) - 100) / 100 / 3) + (2.0 / 3 * rx), ((0.35 * (Rand(0, 200) - 100) / 100 / 3) + (0.35 / 3 * ry) + 0.4), -1];//tgt
      var r = parseInt(Rand(0, 99) / 100.0 * pt.length);
      ball[4] = pt[r][0];//type
      ball[5] = Rand(pt[r][1], pt[r][2]);//spd
      ball[6] = [pt[r][3], Rand(pt[r][4], pt[r][5]) / fp];//xchange
      ball[7] = [pt[r][6], Rand(pt[r][7], pt[r][8]) / fp];//ychange
      ball[8] = [pt[r][9], Rand(pt[r][10], pt[r][11]) / fp];//zchange
      ball[9] = false;//hit

      var lin = new N6LVector([ball[3][0] - ball[0][0], ball[3][1] - ball[0][1], ball[3][2] - ball[0][2]]);
      var up = new N6LVector(3).UnitVec(1);
      var crs = lin.Cross(up);
      var mat = new N6LMatrix([
        [1, 0, 0, 0],
        [0, crs.x[0], crs.x[1], crs.x[2]],
        [0, up.x[0], up.x[1], up.x[2]],
        [0, lin.x[0], lin.x[1], lin.x[2]] ]).NormalMat();
      var vec = new N6LVector([1, 0, 0, ball[5] * 1000 / 60 / 60 / 1000 * frmpermsec],true);
      vec = mat.Mul(vec);
      ball[1][0] = vec.x[1];
      ball[1][1] = vec.x[2];
      ball[1][2] = vec.x[3];

      bl++;
      bound = 0;
      TMan.timer[id].setalerm(function() { BallLoop(id); }, dt3);
    }
    else if(0 < bl) {
      if(bl == 15) {
        var txt = document.querySelector("#type");
        txt.value = ball[4] + " : " + ball[5].toFixed(2); 
      }
      if(ball[9] == false){
         if(ball[6][0] < 18 - ball[0][2]){
          ball[1][0] += ball[6][1];
        }
        if(ball[7][0] < 18 - ball[0][2]){
          ball[1][1] += ball[7][1];
        }
        if(ball[8][0] < 18 - ball[0][2]){
          ball[1][2] += ball[8][1];
          if(0 < ball[1][2]) ball[1][2] = 0;
        }
      }
      var pos = new N6LVector([1, ball[0][0], ball[0][1], ball[0][2]], true);
      var vel = new N6LVector([1, ball[1][0], ball[1][1], ball[1][2]], true);


      if(vel.x[1] < 0) { vel.x[1] -= ine; }
      else if(0 < vel.x[1]) { vel.x[1] += ine; }
      if(vel.x[2] < 0) { vel.x[2] -= ine; }
      else if(0 < vel.x[2]) { vel.x[2] += ine; }
      if(vel.x[3] < 0)  { vel.x[3] -= ine; }
      else if(0 < vel.x[3]) { vel.x[3] += ine; }

      vel.x[2] += grv;

      pos = pos.Add(vel);
      if(pos.x[2] < 0.0) {
        pos.x[2] = -pos.x[2] / 2;
        vel.x[2] = -vel.x[2] / 2;
        bound++;
        if(ishomerun()){
          var txt = document.querySelector("#hr");
          txt.value = parseInt(txt.value) + 1; 
          var txt = document.querySelector("#dbg");
          txt.value = "HomeRun!!!!!!"; 
        }
      }
      ball[0][0] = pos.x[1];
      ball[0][1] = pos.x[2];
      ball[0][2] = pos.x[3];
      ball[1][0] = vel.x[1];
      ball[1][1] = vel.x[2];
      ball[1][2] = vel.x[3];
      var abs = vel.Abs();

      if((ballout(pos)) || (abs < 0.001) || (5 <= bound)) {
        var txt = document.querySelector("#dbg");
        txt.value = ""; 
        bl = -25;
        ball[9] = false;
         return;
      }

      sph.position.set(pos.x[1], pos.x[2], pos.x[3]);
      sdw.position.set(pos.x[1], 0, pos.x[3]);
      if(ball[9] == true){
        camera.position.set(0, 8, -8);
        camera.lookAt( ball[0][0], ball[0][1], ball[0][2] );
        sph.scale.set(8, 8, 8);
        sdw.scale.set(8, 8, 8);
      }
      else {
        camera.position.set(0, 0.7, -1.5);
        camera.lookAt( 0, 0.7, 0 );
        sph.scale.set(1, 1, 1);
        sdw.scale.set(1, 1, 1);
      }
      bl++;
      TMan.timer[id].setalerm(function() { BallLoop(id); }, dt3);
    }
  }

  function BatLoop(id) {
    var el;
    if(bt < 25) {
      bat.position.set(cvpoints[bt].x, cvpoints[bt].y, cvpoints[bt].z);
    }

    if(bt < 4) {
      var q = q0.Slerp(q01, bt / 4);
      var m = q.Matrix();
      el = m.EulerAngle(3, 2, 1);
      bat.rotation.set(el.x[1], el.x[2], el.x[3]);
    }
    else if(bt < 13) {
      var q = q01.Slerp(q1, (bt - 4 ) / 9);
      var m = q.Matrix();
      el = m.EulerAngle(3, 2, 1);
      bat.rotation.set(el.x[1], el.x[2], el.x[3]);
    }
    else if(bt < 25) {
      var q = q1.Slerp(q2, (bt - 13) / 13);
      var m = q.Matrix();
      el = m.EulerAngle(3, 2, 1);
      bat.rotation.set(el.x[1], el.x[2], el.x[3]);
    }

    if((ball[9] == false) && (7 <= bt) && (bt <= 20)){
      var pow = [];
      var vec = new N6LVector([1, cvpoints[bt].x, cvpoints[bt].y, cvpoints[bt].z], true);
      if(ishit(vec, el, pow) == true){
        ball[9] = true;

        hit(vec, pow[0]);
      }
    }

    bt++;
    if((ball[9] == true) || (bt < 30)) TMan.timer[id].setalerm(function() { BatLoop(id); }, dt2);  //バッティング
    else {
      bat.position.set( 0.3, 1.0, -0.3);
      var m = q0.Matrix();
      var el = m.EulerAngle(3, 2, 1);
      bat.rotation.set(el.x[1], el.x[2], el.x[3]);
    }
  }


  cnv0.onclick = function(event) {
    var x, y;
    if (event.offsetX !== undefined) {
      x = event.offsetX;
      y = event.offsetY;
    } else {
      x = event.layerX;
      y = event.layerY;
    }

    var pMouse = new THREE.Vector3(
      ( x / this.clientWidth ) * 2 - 1,
      - ( y / this.clientHeight ) * 2 + 1,
      - 0.333333);

    var proj = new THREE.Vector3(0, 0, 0);
    proj = pMouse.unproject(camera);

    var tgt = proj; 

    var stt = new THREE.Vector3( 0.3, 1.0, -0.3 );
    var end = new THREE.Vector3( 0.3, 1.0, 0.3 );
    if(tgt.x < -0.21) tgt.x = -0.21;
    if(0.21 < tgt.x) tgt.x = 0.21;
    if(tgt.y < 0.4) tgt.y = 0.4;
    if(1.05 < tgt.y) tgt.y = 1.05;
    tgt.z = 0.0;

    tgt = tgt.sub(stt)
    tgt = tgt.multiplyScalar(2.0);
    tgt = tgt.add(stt)

    var curve = new THREE.QuadraticBezierCurve3( stt, tgt, end );
    cvpoints = curve.getPoints( 25 );

    q0 = new N6LQuaternion().UnitQuat();
    var vec = new N6LVector(4);
    var v0 = new N6LVector([0.3, 1.0, 0.0]);
    var v1 = new N6LVector([cvpoints[13].x, cvpoints[13].y, cvpoints[13].z]);
    var v = new N6LVector(v1.Sub(v0));
    var az = new N6LVector(3).UnitVec(2);
    var crs = new N6LVector(v.Cross(az));
    var m1 = new N6LMatrix([
      [1.0, 0.0, 0.0, 0.0],
      [0.0, az.x[0], az.x[1], az.x[2]],
      [0.0, v.x[0], v.x[1], v.x[2]],
      [0.0, crs.x[0], crs.x[1], crs.x[2]] ]).NormalMat();
    q1 = m1.Quaternion();
    var m01 = new N6LMatrix([
      [1.0, 0.0, 0.0, 0.0],
      [0.0, az.x[0], az.x[1], az.x[2]],
      [0.0, crs.x[0], crs.x[1], crs.x[2]],
      [0.0, -v.x[0], -v.x[1], -v.x[2]] ]).NormalMat();
    q01 = m01.Quaternion();
    var m2 = new N6LMatrix(4).UnitMat().RotAxis(vec.UnitVec(2), 30.0 * Math.PI / 180.0);
    q2 = m2.Quaternion();

    bt = 0;
    TMan.timer[1].setalerm(function() { BatLoop(1); }, dt2); // バッティング
  }

}

